连通块中点的数量(并查集)

题目传送门:837.连通块中点的数量

给定一个包含 n 个点(编号为 1∼n)的无向图,初始时图中没有边。

现在要进行 m 个操作,操作共有三种:

  1. C a b,在点 a 和点 b 之间连一条边,a 和 b 可能相等;
  2. Q1 a b,询问点 a 和点 b 是否在同一个连通块中,a 和 b 可能相等;
  3. Q2 a,询问点 a 所在连通块中点的数量;
输入格式

第一行输入整数 n 和 m。

接下来 m 行,每行包含一个操作指令,指令为 C a b,Q1 a b 或 Q2 a 中的一种。

输出格式

对于每个询问指令 Q1 a b,如果 a 和 b 在同一个连通块中,则输出 Yes,否则输出 No。

对于每个询问指令 Q2 a,输出一个整数表示点 a 所在连通块中点的数量

每个结果占一行。

数据范围

1≤n,m≤1e5

输入样例:
复制代码
5 5
C 1 2
Q1 1 2
Q2 1
C 2 5
Q2 5
输出样例:
复制代码
Yes
2
3

试题解析

算法思想

本题依旧使用并查集算法,与简单并查集题目不同的是,本题需要返回集合中点的数量,所以需要定义一个Size数组
并查集基本写法可以参考本文:并查集

  • 初始化每个点的Size都为1
  • 在合并时,同时把Size的数值合并
  • 在查找a对应的连通块中点的数目时,直接输出Sizefind(a)
代码如下
cpp 复制代码
#include<iostream>
using namespace std;
const int N = 100010;
int p[N], Size[N];
int find(int x) {
	if (p[x] != x) p[x] = find(p[x]);
	return p[x];
}

int main() {
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; i++) {
		p[i] = i;
		Size[i] = 1;
	}
	while (m--) {
		char op[3];
		int a, b;
		scanf("%s", op);
		if (op[0] == 'C') {
			scanf("%d%d", &a, &b);
			if (find(a) == find(b)) continue; //如果本身就在同一连通块,则无需合并
			Size[find(b)] += Size[find(a)];//在合并时同时合并Size
			p[find(a)] = find(b);
		} else if (op[1] == '1') {
			scanf("%d%d", &a, &b);
			if (find(a) == find(b)) puts("Yes");
			else puts("No");
		} else if (op[1] == '2') {
			scanf("%d", &a);
			printf("%d\n", Size[find(a)]);//返回当前连通块中元素数目
		}
	}

	return 0;
}
相关推荐
念何架构之路5 小时前
zap采样器与性能优化内幕
算法·性能优化·哈希算法
晒太羊的猫6 小时前
hot100动态规划刷题
算法·动态规划
weixin_531094696 小时前
heap_4内存管理
java·开发语言·算法
余额瞒着我当琳6 小时前
红黑树的实现--红黑树的概念、规则、效率、结构、旋转、查找、验证
数据结构·c++·算法
程序员南飞6 小时前
win系统安装minio
java·数据结构·算法
青少儿编程课堂6 小时前
AC自动机多模式串匹配精讲:校园关键词巡检实战解析
c++·python·算法·bfs·信息学竞赛
longlongzihan7 小时前
LeetCode 5. 最长回文子串:从暴力匹配到中心扩展的思维演进
c++·算法·leetcode
waoooqwe7 小时前
问卷样本真实吗
大数据·数据库·算法·数据分析
苦瓜打怪兽7 小时前
leetcode 热题100(11. 盛最多水的容器)
python·算法·leetcode
w_zero_one8 小时前
链表(4)
java·数据结构·算法